diff -Narup Mtd-orig/util/mkfs.jffs2.c mtd/util/mkfs.jffs2.c
--- Mtd-orig/util/mkfs.jffs2.c	2005-11-28 10:26:55.000000000 +0100
+++ mtd/util/mkfs.jffs2.c	2005-11-29 09:31:55.000000000 +0100
@@ -64,11 +64,10 @@
 #include <time.h>
 #include <getopt.h>
 #include <byteswap.h>
-#define crc32 __complete_crap
-#include <zlib.h>
-#undef crc32
 #include "crc32.h"
 
+#define DEFAULT_COMPR_CONTROL "deflate"
+
 /* Do not use the wierd XPG version of basename */
 #undef basename
 
@@ -673,6 +672,9 @@ int page_size = 4096;
 
 #include "compr.h"
 
+char *comprcontrol = NULL;
+struct compress_ctx *ctx;
+
 static void full_write(int fd, const void *buf, int len)
 {
 	int ret;
@@ -774,7 +776,7 @@ static void write_dirent(struct filesyst
 
 static void write_regular_file(struct filesystem_entry *e)
 {
-	int fd, len;
+	int fd, len, ret;
 	uint32_t ver;
 	unsigned int offset;
 	unsigned char *buf, *cbuf, *wbuf;
@@ -826,7 +828,6 @@ static void write_regular_file(struct fi
 
 		while (len) {
 			uint32_t dsize, space;
-                        uint16_t compression;
 
 			pad_block_if_less_than(sizeof(ri) + JFFS2_MIN_DATA_LEN);
 
@@ -837,14 +838,21 @@ static void write_regular_file(struct fi
 			if (space > dsize)
 				space = dsize;
 
-			compression = jffs2_compress(tbuf, &cbuf, &dsize, &space);
-                        ri.compr = compression & 0xff;
-                        ri.usercompr = (compression >> 8) & 0xff;
-			if (ri.compr) {
+			cbuf = malloc(space);
+			if (!cbuf) {
+				perror_msg_and_die("Memory allocation error");
+			}
+
+			ret = compress(&ctx, tbuf, dsize, cbuf, &space);
+			if (ret > 0) {
+				ri.compr = JFFS2_COMPR_ENGINE;
+				ri.usercompr = ret;
 				wbuf = cbuf;
 			} else {
-				wbuf = tbuf;
+				ri.compr = JFFS2_COMPR_NONE;
+				ri.usercompr = 0;
 				dsize = space;
+				wbuf = tbuf;
 			}
 
 			ri.totlen = cpu_to_je32(sizeof(ri) + space);
@@ -866,7 +874,7 @@ static void write_regular_file(struct fi
 			len -= dsize;
 			offset += dsize;
 
-                        if (tbuf!=cbuf) if (!cbuf) free(cbuf);
+			free(cbuf);
 		}
 	}
 	if (!je32_to_cpu(ri.version)) {
@@ -1167,10 +1175,7 @@ static struct option long_options[] = {
 	{"squash-perms", 0, NULL, 'P'},
 	{"faketime", 0, NULL, 'f'},
 	{"devtable", 1, NULL, 'D'},
-	{"compression-mode", 1, NULL, 'm'},
-	{"disable-compressor", 1, NULL, 'x'},
-	{"test-compression", 0, NULL, 't'},
-	{"compressor-priority", 1, NULL, 'y'},
+	{"compressors", 1, NULL, 'm'},
 	{"incremental", 1, NULL, 'i'},
 	{NULL, 0, NULL, 0}
 };
@@ -1186,15 +1191,7 @@ static char *helptext =
 	"  -s, --pagesize=SIZE     Use page size (max data node size) SIZE (default: 4KiB)\n"
 	"  -e, --eraseblock=SIZE   Use erase block size SIZE (default: 64KiB)\n"
 	"  -c, --eraseblock-header=SIZE  Size of eraseblock header (default 28)\n"
-	"  -m, --compr-mode=MODE   Select compression mode (default: priortiry)\n"
-        "  -x, --disable-compressor=COMPRESSOR_NAME\n"
-        "                          Disable a compressor\n"
-        "  -X, --enable-compressor=COMPRESSOR_NAME\n"
-        "                          Enable a compressor\n"
-        "  -y, --compressor-priority=PRIORITY:COMPRESSOR_NAME\n"
-        "                          Set the priority of a compressor\n"
-        "  -L, --list-compressors  Show the list of the avaiable compressors\n"
-        "  -t, --test-compression  Call decompress and compare with the original (for test)\n"
+	"  -m, --compressors       Compressors control string, eg. \"" DEFAULT_COMPR_CONTROL "\" which is the default\n"
 	"  -n, --no-eraseblock-headers   Don't add a eraseblock header to every eraseblock\n"
 	"  -o, --output=FILE       Output to FILE (default: stdout)\n"
 	"  -l, --little-endian     Create a little-endian filesystem\n"
@@ -1363,13 +1360,9 @@ int main(int argc, char **argv)
 	struct stat sb;
 	FILE *devtable = NULL;
 	struct filesystem_entry *root;
-        char *compr_name = NULL;
-        int compr_prior  = -1;
-
-        jffs2_compressors_init();
 
 	while ((opt = getopt_long(argc, argv,
-					"D:d:r:s:o:qUPfh?vVe:lbp::nc:m:x:X:Lty:i:", long_options, &c)) >= 0)
+					"D:d:r:s:o:qUPfh?vVe:lbp::nc:m:i:", long_options, &c)) >= 0) 
 	{
 		switch (opt) {
 			case 'D':
@@ -1489,39 +1482,9 @@ int main(int argc, char **argv)
 					error_msg_and_die("ebh size must be < eraseblock size");
 				}
 				break;
-                        case 'm':
-                                if (jffs2_set_compression_mode_name(optarg)) {
-					error_msg_and_die("Unknown compression mode %s", optarg);
-				}
-                                break;
-                        case 'x':
-                                if (jffs2_disable_compressor_name(optarg)) {
-                                        error_msg_and_die("Unknown compressor name %s",optarg);
-                                }
-                                break;
-                        case 'X':
-                                if (jffs2_enable_compressor_name(optarg)) {
-                                        error_msg_and_die("Unknown compressor name %s",optarg);
-                                }
-                                break;
-                        case 'L':
-                                error_msg_and_die("\n%s",jffs2_list_compressors());
-                                break;
-                        case 't':
-                                jffs2_compression_check_set(1);
-                                break;
-                        case 'y':
-                                compr_name = malloc(strlen(optarg));
-                                sscanf(optarg,"%d:%s",&compr_prior,compr_name);
-                                if ((compr_prior>=0)&&(compr_name)) {
-                                        if (jffs2_set_compressor_priority(compr_name, compr_prior))
-	                                        exit(EXIT_FAILURE);
-                                }
-                                else {
-                                        error_msg_and_die("Cannot parse %s",optarg);
-                                }
-                                free(compr_name);
-                                break;
+			case 'm':
+				comprcontrol = xstrdup(optarg);
+				break;
 			case 'i':
 				if (in_fd != -1) {
 					error_msg_and_die("(incremental) filename specified more than once");
@@ -1533,6 +1496,10 @@ int main(int argc, char **argv)
 				break;
 		}
 	}
+	if (!comprcontrol) {
+		comprcontrol = (char *) malloc(sizeof(DEFAULT_COMPR_CONTROL));
+		strcpy(comprcontrol, DEFAULT_COMPR_CONTROL);
+	}
 	if (out_fd == -1) {
 		if (isatty(1)) {
 			error_msg_and_die(helptext);
@@ -1551,6 +1518,9 @@ int main(int argc, char **argv)
 	if(in_fd != -1)
 		parse_image();
 
+	if (!(ctx = create_compress_context(comprcontrol)))
+		perror_msg_and_die("compressor init failed");
+
 	root = recursive_add_host_directory(NULL, "/", cwd);
 
 	if (devtable)
@@ -1565,16 +1535,14 @@ int main(int argc, char **argv)
 
 	close(out_fd);
 
-        if (verbose) {
-                char *s = jffs2_stats();
-                fprintf(stderr,"\n\n%s",s);
-                free(s);
-        }
-        if ((verbose)||(jffs2_compression_check_get()&&(jffs2_compression_check_errorcnt_get()))) {
-                fprintf(stderr,"Compression errors: %d\n",jffs2_compression_check_errorcnt_get());
-        }
+	if (verbose) {
+		char *s = compress_stats(&ctx);
+		fprintf(stderr, "\n\n%s", s);
+		free(s);
+	}
 
-        jffs2_compressors_exit();
+	destroy_compress_context(&ctx);
+	free(comprcontrol);
 
 	return 0;
 }
